#include <iostream>
#include <cmath>

using namespace std;

int main() {
	int n, m, c;
	cin>>n>>m;
	
	int b[m];
	for(int i=0; i<m; i++){
		cin>>b[i];
	}
	
	int a[n];
	for(int i=0; i<n; i++){
		a[i] = i+1;
	}
	
	for(int i=0; i<=n-m; i++){
		for (int j=1; j<=m; j++){
  			a[i + b[j-1] - 1] = a[i + j - 1];
  		}
	}
	
	cin>>c;
	long long int x=0;
	for(int i=1; i<=n; i++){
			x+=int((int(pow(c, i))%998244353)*a[i-1]) % 998244353;
	}
	
	cout<<x;
	
	return 0;
}